'From Pharo8.0.0 of 31 January 2020 [Build information: Pharo-8.0.0+build.1127.sha.353dabe053b2cb1b54837e286965e532cf330aad (64 Bit)] on 18 February 2020 at 9:12:15.933182 am'!
SlangAbstractTestCase subclass: #SlangBasicTypeInferenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'VMMaker-Tests'!
!SlangBasicTypeInferenceTest commentStamp: '' prior: 0!
Basic tests for the type inference used in CCodeGenerator.
Support methods are in SlangTypeInferenceTestClass.
There is only one possible type by node, no ambiguities.

1 Constant
	test constantNode in a method.
	tests are tailor made for the current TConstantNode >> #typeOrNilFrom:in:.

2 Return-constant
	test return a constant node in a method.
	uses the previous categorie's values.

3 Return-temp-assigned-constant
	assign a temporary node with a constant
	then returns the temporary variable in the next statement.
	
4 Return-temp-assigned-message
	assign a temporary node with a message
	then returns the temporary variable in the next statement.
	
5 Return-explicit-temp
	returns a temporary typed by a pragma #var:type:.

6 Return-explicit-arg
	returns an argument typed by a pragma #var:type:.!


!SlangBasicTypeInferenceTest methodsFor: 'return-message-send'!
testReturnAnIntGreater64MessageSend
	| tMethod |
	tMethod := ccg methodNamed: #returnAnIntGreater64MessageSend.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.
	"the method return type is sqint, so it's coherent, see testReturnAnIntGreater64MessageSend"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-message-send'!
testReturnABigNegativeIntegerMessageSend
	| tMethod |
	tMethod := ccg methodNamed: #returnABigNegativeIntegerMessageSend.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqLong.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #sqLong.
	self assert: tMethod returnType equals: #sqLong.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-message-send'!
testReturnANilMessageSend
	| tMethod |
	tMethod := ccg methodNamed: #returnANilMessageSend.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-message-send'!
testReturnAStringMessageSend
	| tMethod |
	tMethod := ccg methodNamed: #returnAStringMessageSend.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'char *'.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #'char *'.
	self assert: tMethod returnType equals: #'char *'.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-message-send'!
testReturnAnIntEqual64MessageSend
	| tMethod |
	tMethod := ccg methodNamed: #returnAnIntEqual64MessageSend.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.
	"the method return type is sqint, so it's coherent, see testReturnAnIntEqual64MessageSend"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-message-send'!
testReturnATrueMessageSend
	| tMethod |
	tMethod := ccg methodNamed: #returnATrueMessageSend.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-message-send'!
testReturnAnIntLesser32MessageSend
	| tMethod |
	tMethod := ccg methodNamed: #returnAnIntLesser32MessageSend.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.
	"the method return type is sqint, so it's coherent, see testReturnAnIntLesser64MessageSend"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-message-send'!
testReturnAFloatMessageSend
	| tMethod |
	tMethod := ccg methodNamed: #returnAFloatMessageSend.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #double.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #double.
	self assert: tMethod returnType equals: #double.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-message-send'!
testReturnASmallNegativeIntegerMessageSend
	| tMethod |
	tMethod := ccg methodNamed: #returnASmallNegativeIntegerMessageSend.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-message-send'!
testReturnAFalseMessageSend
	| tMethod |
	tMethod := ccg methodNamed: #returnAFalseMessageSend.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-message-send'!
testReturnAnIntEqual32MessageSend
	| tMethod |
	tMethod := ccg methodNamed: #returnAnIntEqual32MessageSend.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.
	"the method return type is sqint, so it's coherent, see testReturnAnIntEqual32MessageSend"! !


!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-arg'!
testReturnExplicitArgInt
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitArgInt:.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int.
	self assert: tMethod returnType equals: #sqInt! !

!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-arg'!
testReturnExplicitArgDouble
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitArgDouble:.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #double.
	self assert: tMethod returnType equals: #double! !

!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-arg'!
testReturnExplicitArgLongLong
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitArgLongLong:.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'long long'.
	self assert: tMethod returnType equals: #sqLong! !

!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-arg'!
testReturnExplicitArgRandom
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitArgRandom:.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #completelyRandom.
	self assert: tMethod returnType equals: #completelyRandom! !

!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-arg'!
testReturnExplicitArgUnsignedInt
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitArgUnsignedInt:.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'unsigned int'.
	self assert: tMethod returnType equals: #usqInt! !

!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-arg'!
testReturnExplicitArgUnsignedLongLong
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitArgUnsignedLongLong:.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'unsigned long long'.
	self assert: tMethod returnType equals: #usqLong! !

!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-arg'!
testReturnExplicitArgFloat
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitArgFloat:.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #float.
	self assert: tMethod returnType equals: #float! !

!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-arg'!
testReturnExplicitArgString
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitArgString:.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'char *'.
	self assert: tMethod returnType equals: #'char *'! !


!SlangBasicTypeInferenceTest methodsFor: 'return-constant'!
testReturnAFalseConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnAFalseConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int.
	self assert: tMethod returnType equals: #sqInt! !

!SlangBasicTypeInferenceTest methodsFor: 'return-constant'!
testReturnAnIntGreater64ConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnAnIntGreater64ConstantNode.
		
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'long long'.
	self assert: tMethod returnType equals: #sqInt
	"returning an integer constants is the same as returning nothing"
	"this therefore return a sqInt"
	"see start of the CCodeGenerator >> harmonizeReturnTypesIn: method"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-constant'!
testReturnANilConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnANilConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int.
	self assert: tMethod returnType equals: #sqInt! !

!SlangBasicTypeInferenceTest methodsFor: 'return-constant'!
testReturnASmallNegativeIntegerConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnASmallNegativeIntegerConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int.
	self assert: tMethod returnType equals: #sqInt! !

!SlangBasicTypeInferenceTest methodsFor: 'return-constant'!
testReturnABigNegativeIntegerConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnABigNegativeIntegerConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'long long'.
	self assert: tMethod returnType equals: #sqLong! !

!SlangBasicTypeInferenceTest methodsFor: 'return-constant'!
testReturnATrueConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnATrueConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int.
	self assert: tMethod returnType equals: #sqInt! !

!SlangBasicTypeInferenceTest methodsFor: 'return-constant'!
testReturnAnIntEqual64ConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnAnIntEqual64ConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'unsigned long long'.
	self assert: tMethod returnType equals: #sqInt
	"returning an integer constants is the same as returning nothing"
	"this therefore return a sqInt"
	"see start of the CCodeGenerator >> harmonizeReturnTypesIn: method"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-constant'!
testReturnAnIntLess32ConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnAnIntLesser32ConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int.
	self assert: tMethod returnType equals: #sqInt
	"returning constants is the same as returning nothing"
	"this therefore return a sqInt"
	"see start of the CCodeGenerator >> harmonizeReturnTypesIn: method"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-constant'!
testReturnAnIntEqual32ConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnAnIntEqual32ConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'unsigned int'.
	self assert: tMethod returnType equals: #sqInt
	"returning an integer constants is the same as returning nothing"
	"this therefore return a sqInt"
	"see start of the CCodeGenerator >> harmonizeReturnTypesIn: method"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-constant'!
testReturnFloatConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnAFloatConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #double.
	self assert: tMethod returnType equals: #double
	! !

!SlangBasicTypeInferenceTest methodsFor: 'return-constant'!
testReturnAStringConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnAStringConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'char *'.
	self assert: tMethod returnType equals: #'char *'! !


!SlangBasicTypeInferenceTest methodsFor: 'constant'!
testASmallNegativeIntegerConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #aSmallNegativeIntegerConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int! !

!SlangBasicTypeInferenceTest methodsFor: 'constant'!
testABigNegativeIntegerConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #aBigNegativeIntegerConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'long long'! !

!SlangBasicTypeInferenceTest methodsFor: 'constant'!
testANilConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #aNilConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int! !

!SlangBasicTypeInferenceTest methodsFor: 'constant'!
testAnIntEqual32ConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #anIntEqual32ConstantNode.
		
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'unsigned int'! !

!SlangBasicTypeInferenceTest methodsFor: 'constant'!
testAnIntGreater64ConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #anIntGreater64ConstantNode.
		
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'long long'! !

!SlangBasicTypeInferenceTest methodsFor: 'constant'!
testATrueConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #aTrueConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int! !

!SlangBasicTypeInferenceTest methodsFor: 'constant'!
testAnIntEqual64ConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #anIntEqual64ConstantNode.
		
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'unsigned long long'! !

!SlangBasicTypeInferenceTest methodsFor: 'constant'!
testAFloatConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #aFloatConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #double! !

!SlangBasicTypeInferenceTest methodsFor: 'constant'!
testAStringConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #aStringConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'char *'! !

!SlangBasicTypeInferenceTest methodsFor: 'constant'!
testAnIntLess32ConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #anIntLesser32ConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int.
! !

!SlangBasicTypeInferenceTest methodsFor: 'constant'!
testAFalseConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #aFalseConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int! !


!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-temp'!
testReturnExplicitTempDouble
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitTempDouble.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #double.
	self assert: tMethod returnType equals: #double! !

!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-temp'!
testReturnExplicitTempUnsignedInt
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitTempUnsignedInt.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'unsigned int'.
	self assert: tMethod returnType equals: #usqInt! !

!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-temp'!
testReturnExplicitTempRandom
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitTempRandom.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #completelyRandom.
	self assert: tMethod returnType equals: #completelyRandom! !

!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-temp'!
testReturnExplicitTempFloat
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitTempFloat.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #float.
	self assert: tMethod returnType equals: #float! !

!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-temp'!
testReturnExplicitTempInt
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitTempInt.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int.
	self assert: tMethod returnType equals: #sqInt! !

!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-temp'!
testReturnExplicitTempUnsignedLongLong
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitTempUnsignedLongLong.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'unsigned long long'.
	self assert: tMethod returnType equals: #usqLong! !

!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-temp'!
testReturnExplicitTempLongLong
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitTempLongLong.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'long long'.
	self assert: tMethod returnType equals: #sqLong! !

!SlangBasicTypeInferenceTest methodsFor: 'return-explicit-temp'!
testReturnExplicitTempString
	| tMethod |
	tMethod := ccg methodNamed: #returnExplicitTempString.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'char *'.
	self assert: tMethod returnType equals: #'char *'! !


!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-const'!
testReturnTempFloatConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempFloatConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #double. " assignementNode "
	self assert: (ccg typeFor: tMethod statements first value in: tMethod) equals: #double. " value, constantNode "
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt. " variable, temporaryNode "
	self assert: tMethod returnType equals: #sqInt.
	
	self assert: false "type lost"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-const'!
testReturnTempIntLesser32ConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempIntLesser32ConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int. " assignementNode "
	self assert: (ccg typeFor: tMethod statements first value in: tMethod) equals: #int. " value, constantNode "
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt. " variable, temporaryNode "
	self assert: tMethod returnType equals: #sqInt.
	
	self assert: false "unexpected type conversion"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-const'!
testReturnTempFalseConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempFalseConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int. " assignementNode "
	self assert: (ccg typeFor: tMethod statements first value in: tMethod) equals: #int. " value, constantNode "
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt. " variable, temporaryNode "
	self assert: tMethod returnType equals: #sqInt.
	
	self assert: false "unexpected type conversion"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-const'!
testReturnTempIntEqual32ConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempIntEqual32ConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'unsigned int'. " assignementNode "
	self assert: (ccg typeFor: tMethod statements first value in: tMethod) equals: #'unsigned int'. " value, constantNode "
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt. " variable, temporaryNode "
	self assert: tMethod returnType equals: #sqInt.
	
	self assert: false "unexpected type conversion"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-const'!
testReturnTempIntEqual64ConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempIntEqual64ConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'unsigned long long'. " assignementNode "
	self assert: (ccg typeFor: tMethod statements first value in: tMethod) equals: #'unsigned long long'. " value, constantNode "
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt. " variable, temporaryNode "
	self assert: tMethod returnType equals: #sqInt.
	
	self assert: false "unexpected type conversion, shouldn't it at least be an sqLong? or better, an uSqLong"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-const'!
testReturnTempTrueConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempTrueConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int. " assignementNode "
	self assert: (ccg typeFor: tMethod statements first value in: tMethod) equals: #int. " value, constantNode "
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt. " variable, temporaryNode "
	self assert: tMethod returnType equals: #sqInt.
	
	self assert: false "Unexpected conversion"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-const'!
testReturnTempSmallNegativeIntegerConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempSmallNegativeIntegerConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int. " assignementNode "
	self assert: (ccg typeFor: tMethod statements first value in: tMethod) equals: #int. " value, constantNode "
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt. " variable, temporaryNode "
	self assert: tMethod returnType equals: #sqInt.
	
	self assert: false "unexpected type conversion"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-const'!
testReturnTempIntGreater64ConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempIntGreater64ConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'long long'. " assignementNode "
	self assert: (ccg typeFor: tMethod statements first value in: tMethod) equals: #'long long'. " value, constantNode "
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt. " variable, temporaryNode "
	self assert: tMethod returnType equals: #sqInt.
	
	self assert: false "unexpected type conversion, shouldn't it be at least an sqLong?"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-const'!
testReturnTempStringConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempStringConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'char *'. " assignementNode "
	self assert: (ccg typeFor: tMethod statements first value in: tMethod) equals: #'char *'. " value, constantNode "
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt. " variable, temporaryNode "
	self assert: tMethod returnType equals: #sqInt.
	
	self assert: false "type lost"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-const'!
testReturnTempNilConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempNilConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int. " assignementNode "
	self assert: (ccg typeFor: tMethod statements first value in: tMethod) equals: #int. " value, constantNode "
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt. " variable, temporaryNode "
	self assert: tMethod returnType equals: #sqInt.
	
	self assert: false "unexpected type conversion"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-const'!
testReturnTempBigNegativeIntegerConstantNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempBigNegativeIntegerConstantNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'long long'. " assignementNode "
	self assert: (ccg typeFor: tMethod statements first value in: tMethod) equals: #'long long'. " value, constantNode "
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt. " variable, temporaryNode "
	self assert: tMethod returnType equals: #sqInt.
	
	self assert: false "unexpected type conversion, shouldn't it be a sqLong?"! !


!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-message'!
testReturnTempIntEqual32MessageNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempIntEqual32MessageNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-message'!
testReturnTempFalseMessageNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempFalseMessageNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-message'!
testReturnTempStringMessageNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempStringMessageNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'char *'.
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #'char *'.
	self assert: tMethod returnType equals: #'char *'.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-message'!
testReturnTempIntEqual64MessageNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempIntEqual64MessageNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-message'!
testReturnTempFloatMessageNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempFloatMessageNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #double.
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.
	
	self assert: false "wait what"! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-message'!
testReturnTempNilMessageNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempNilMessageNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-message'!
testReturnTempTrueMessageNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempTrueMessageNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-message'!
testReturnTempIntGreater64MessageNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempIntGreater64MessageNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-message'!
testReturnTempSmallNegativeIntegerMessageNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempSmallNegativeIntegerMessageNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-message'!
testReturnTempBigNegativeIntegerMessageNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempBigNegativeIntegerMessageNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqLong.
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqLong.
	self assert: tMethod returnType equals: #sqLong.! !

!SlangBasicTypeInferenceTest methodsFor: 'return-temp-assigned-message'!
testReturnTempIntLesser32MessageNode
	| tMethod |
	tMethod := ccg methodNamed: #returnTempIntLesser32MessageNode.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #sqInt.
	self assert: (ccg typeFor: tMethod statements first variable in: tMethod) equals: #sqInt.
	self assert: tMethod returnType equals: #sqInt.! !


!SlangBasicTypeInferenceTest methodsFor: 'running'!
setUp
	super setUp.
	ccg addClass: SlangBasicTypeInferenceTestClass.
	ccg inferTypesForImplicitlyTypedVariablesAndMethods.
! !
