'From Pharo8.0.0 of 31 January 2020 [Build information: Pharo-8.0.0+build.1127.sha.353dabe053b2cb1b54837e286965e532cf330aad (64 Bit)] on 18 February 2020 at 9:12:16.017196 am'!
InterpreterPlugin subclass: #SlangTestPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'VMMaker-Plugins'!

!SlangTestPlugin methodsFor: 'primitives'!
testTypePropagationBasicAt
	"Ensure that types are propagated correctly"
	| buffer shouldBeInt |
	<export: true>
	<var: #buffer declareC: 'sqInt buffer[1] = { 12345 }'>
	"the resulting byte should be truncated by the functions and expanded back to sqInt"
	shouldBeInt := self getByteNonFunctionalAt: buffer.
	interpreterProxy pushBool: shouldBeInt < 256.
! !

!SlangTestPlugin methodsFor: 'primitives'!
testTypePropagationBasicFunctional
	"Ensure that types are propagated correctly"
	| shouldBeInt |
	<export: true>
	"the resulting byte should be truncated by the functions and expanded back to sqInt"
	shouldBeInt := self getByteFunctional.
	interpreterProxy pushBool: shouldBeInt < 256.
! !

!SlangTestPlugin methodsFor: 'primitives'!
testTypePropagationBasicNoPropagateFunctionalAt
	"Ensure that types are propagated correctly"
	| buffer shouldBeInt |
	<export: true>
	<var: #buffer declareC: 'sqInt buffer[1] = { 12345 }'>
	shouldBeInt := self getByteFunctionalAt: buffer.
	"shoudBeInt should be int, not unsigned char"
	shouldBeInt := 12345.
	interpreterProxy pushBool: shouldBeInt > 256.! !

!SlangTestPlugin methodsFor: 'primitives'!
getByteNonFunctionalAt: addr
	"Return a byte from a non-functional method"
	<returnTypeC: 'unsigned char'>
	self msg: 'yo'.
	^interpreterProxy longAt: addr! !

!SlangTestPlugin methodsFor: 'primitives'!
testTypePropagationBasicFunctionalAt
	"Ensure that types are propagated correctly"
	| buffer shouldBeInt |
	<export: true>
	<var: #buffer declareC: 'sqInt buffer[1] = { 12345 }'>
	"the resulting byte should be truncated by the functions and expanded back to sqInt"
	shouldBeInt := self getByteFunctionalAt: buffer.
	interpreterProxy pushBool: shouldBeInt < 256.
! !

!SlangTestPlugin methodsFor: 'primitives'!
testTypePropagationBasicNoPropagate
	"Ensure that types are propagated correctly"
	| shouldBeInt |
	<export: true>
	shouldBeInt := self getByteNonFunctional.
	"shoudBeInt should be int, not unsigned char"
	shouldBeInt := 12345.
	interpreterProxy pushBool: shouldBeInt > 256.! !

!SlangTestPlugin methodsFor: 'primitives'!
getByteFunctional
	"Return a byte from a (semi-)functional method"
	<returnTypeC: 'unsigned char'>
	^12345! !

!SlangTestPlugin methodsFor: 'primitives'!
testTypePropagationBasic
	"Ensure that types are propagated correctly"
	| shouldBeInt |
	<export: true>
	"the resulting byte should be truncated by the functions and expanded back to sqInt"
	shouldBeInt := self getByteNonFunctional.
	interpreterProxy pushBool: shouldBeInt < 256.
! !

!SlangTestPlugin methodsFor: 'primitives'!
getByteFunctionalAt: addr
	"Return a byte from a (semi-)functional method"
	<returnTypeC: 'unsigned char'>
	^interpreterProxy longAt: addr! !

!SlangTestPlugin methodsFor: 'primitives'!
testTypePropagationBasicNoPropagateFunctional
	"Ensure that types are propagated correctly"
	| shouldBeInt |
	<export: true>
	shouldBeInt := self getByteFunctional.
	"shoudBeInt should be int, not unsigned char"
	shouldBeInt := 12345.
	interpreterProxy pushBool: shouldBeInt > 256.! !

!SlangTestPlugin methodsFor: 'primitives'!
testTypePropagationBasicNoPropagateAt
	"Ensure that types are propagated correctly"
	| buffer shouldBeInt |
	<export: true>
	<var: #buffer declareC: 'sqInt buffer[1] = { 12345 }'>
	shouldBeInt := self getByteNonFunctionalAt: buffer.
	"shoudBeInt should be int, not unsigned char"
	shouldBeInt := 12345.
	interpreterProxy pushBool: shouldBeInt > 256.! !

!SlangTestPlugin methodsFor: 'primitives'!
getByteNonFunctional
	"Return a byte from a non-functional method"
	<returnTypeC: 'unsigned char'>
	self msg: 'yo'.
	^12345! !
