'From Pharo8.0.0 of 31 January 2020 [Build information: Pharo-8.0.0+build.1127.sha.353dabe053b2cb1b54837e286965e532cf330aad (64 Bit)] on 18 February 2020 at 9:12:15.968443 am'!
SlangAbstractTestCase subclass: #SlangTypeForDereferenceTest
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'VMMaker-Tests'!

!SlangTypeForDereferenceTest methodsFor: 'running'!
setUp
	super setUp.
	ccg addClass: SlangTypeForDereferenceTestClass.
	ccg inferTypesForImplicitlyTypedVariablesAndMethods.! !


!SlangTypeForDereferenceTest methodsFor: 'tests'!
testTwoAtOnMatrix
	| tMethod |
	tMethod := ccg methodNamed: #aMethodReturningTwoAtOnAMatrix.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first expression receiver in: tMethod) equals: #'int *'."inner at:"
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #int."outer at:"
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int."return node"
	self assert: tMethod returnType equals: #sqInt.

	self assert: false. "Unexpected type conversion"! !

!SlangTypeForDereferenceTest methodsFor: 'tests'!
testAtOnArray
	| tMethod |
	tMethod := ccg methodNamed: #aMethodReturningAnAtOnAnArray.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #int."at: node"
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #int."returnNode"
	self assert: tMethod returnType equals: #sqInt.
	
	self assert: false. "Unexpected type conversion"! !

!SlangTypeForDereferenceTest methodsFor: 'tests'!
testReturnPointerTypeExplicitTempVariable
	| tMethod |
	tMethod := ccg methodNamed: #aMethodReturningAPointerType.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #'int *'."variable node"
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'int *'."return node"
	self assert: tMethod returnType equals: #'int *'! !

!SlangTypeForDereferenceTest methodsFor: 'tests'!
testAtOnMatrix
	| tMethod |
	tMethod := ccg methodNamed: #aMethodReturningAnAtOnAMatrix.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #'int *'."at: node"
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'int *'."returnNode"
	self assert: tMethod returnType equals: #'int *'.! !

!SlangTypeForDereferenceTest methodsFor: 'tests'!
testSelfMessageReturningPointerType
	| tMethod |
	tMethod := ccg methodNamed: #aMethodReturningAPointerType.
	
	self assert: tMethod isNotNil.
	self assert: (ccg typeFor: tMethod statements first expression in: tMethod) equals: #'int *'."message node"
	self assert: (ccg typeFor: tMethod statements first in: tMethod) equals: #'int *'."returnNode"
	self assert: tMethod returnType equals: #'int *'! !
