'From Pharo8.0.0 of 31 January 2020 [Build information: Pharo-8.0.0+build.1127.sha.353dabe053b2cb1b54837e286965e532cf330aad (64 Bit)] on 18 February 2020 at 9:12:15.97316 am'!
SlangAbstractTestCase subclass: #SlangTypePromotionTest
	instanceVariableNames: ''
	classVariableNames: ''
	package: 'VMMaker-Tests'!

!SlangTypePromotionTest methodsFor: 'general'!
testNilAndInt
	| firstType secondType resType |
	firstType := nil.
	secondType := #int.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: nil.
	! !

!SlangTypePromotionTest methodsFor: 'general'!
testFloatAndNil
	| firstType secondType resType |
	firstType := #float.
	secondType := nil.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #float.
	
	"this feels wrong"
	"inconsistent with integer types too"
	self assert: false.! !

!SlangTypePromotionTest methodsFor: 'general'!
testIntAndNil
	| firstType secondType resType |
	firstType := #int.
	secondType := nil.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: nil.
	! !

!SlangTypePromotionTest methodsFor: 'general'!
testNilAndNil
	| firstType secondType resType |
	firstType := nil.
	secondType := nil.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: nil.
	! !

!SlangTypePromotionTest methodsFor: 'general'!
testNilAndFloat
	| firstType secondType resType |
	firstType := nil.
	secondType := #float.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #float.
	
	"this feels wrong"
	"inconsistent with integer types too"
	self assert: false.! !


!SlangTypePromotionTest methodsFor: 'float-types'!
testLongLongAndFloat
	| firstType secondType resType |
	firstType := #'long long'.
	secondType := #float.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #float.
	self assert: (ccg isFloatingPointCType: resType).
	! !

!SlangTypePromotionTest methodsFor: 'float-types'!
testDoubleAndDouble
	| firstType secondType resType |
	firstType := #double.
	secondType := #double.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #double.
	self assert: (ccg isFloatingPointCType: resType).! !

!SlangTypePromotionTest methodsFor: 'float-types'!
testFloatAndDouble
	| firstType secondType resType |
	firstType := #float.
	secondType := #double.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #double.
	self assert: (ccg isFloatingPointCType: resType).
	! !

!SlangTypePromotionTest methodsFor: 'float-types'!
testFloatAndFloat
	| firstType secondType resType |
	firstType := #float.
	secondType := #float.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #float.
	self assert: (ccg isFloatingPointCType: resType).
	! !

!SlangTypePromotionTest methodsFor: 'float-types'!
testDoubleAndFloat
	| firstType secondType resType |
	firstType := #double.
	secondType := #float.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #double.
	self assert: (ccg isFloatingPointCType: resType).
	! !

!SlangTypePromotionTest methodsFor: 'float-types'!
testIntAndFloat
	| firstType secondType resType |
	firstType := #int.
	secondType := #float.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #float.
	self assert: (ccg isFloatingPointCType: resType).
	! !

!SlangTypePromotionTest methodsFor: 'float-types'!
testCharAndFloat
	"representative of two types bigger than sizeOf(int) and with same size"
	| firstType secondType resType |
	firstType := #char.
	secondType := #float.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #float.
	self assert: (ccg isFloatingPointCType: resType).! !


!SlangTypePromotionTest methodsFor: 'unsigned-priority'!
testIntAndUnsignedInt
	"representative of two types bigger than sizeOf(int) and with same size"
	| firstType secondType resType |
	firstType := #int.
	secondType := #'unsigned int'.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #'unsigned int'.
	
	"check that the system is in the assumed state."
	self assert: (ccg isIntegralCType: #int).
	self assert: (ccg sizeOfIntegralCType: #int) equals: 4.
	self assert: (ccg isIntegralCType: #'unsigned int').
	self assert: (ccg sizeOfIntegralCType: #'unsigned int') equals: 4.! !

!SlangTypePromotionTest methodsFor: 'unsigned-priority'!
testIntAndUnsignedChar
	"representative of an unsigned that is ignored because of integerType promotion"
	| firstType secondType resType |
	firstType := #int.
	secondType := #'unsigned char'.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #int.
	
	"check that the system is in the assumed state."
	self assert: (ccg isIntegralCType: #int).
	self assert: (ccg sizeOfIntegralCType: #int) equals: 4.
	self assert: (ccg isIntegralCType: #'unsigned char').
	self assert: (ccg sizeOfIntegralCType: #'unsigned char') equals: 1.! !

!SlangTypePromotionTest methodsFor: 'unsigned-priority'!
testUnsignedIntAndInt
	"representative of two types bigger than sizeOf(int) and with same size"
	| firstType secondType resType |
	firstType := #'unsigned int'.
	secondType := #'int'.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #'unsigned int'.
	
	"check that the system is in the assumed state."
	self assert: (ccg isIntegralCType: #'unsigned int').
	self assert: (ccg sizeOfIntegralCType: #'unsigned int') equals: 4.
	self assert: (ccg isIntegralCType: #int).
	self assert: (ccg sizeOfIntegralCType: #int) equals: 4.! !

!SlangTypePromotionTest methodsFor: 'unsigned-priority'!
testUnsignedIntAndLongLong
	"representative of an unsigned that is ignored because of integerType promotion"
	| firstType secondType resType |
	firstType := #'unsigned int'.
	secondType := #'long long'.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #'long long'.
	
	"check that the system is in the assumed state."
	self assert: (ccg isIntegralCType: #'unsigned int').
	self assert: (ccg sizeOfIntegralCType: #'unsigned int') equals: 4.
	self assert: (ccg isIntegralCType: #'long long').
	self assert: (ccg sizeOfIntegralCType: #'long long') equals: 8.! !


!SlangTypePromotionTest methodsFor: 'integer-types'!
testIntAndLongLong
	"representative of a different size types"
	| firstType secondType resType |
	firstType := #int .
	secondType := #'long long'.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #'long long'.
	
	"check that the system is in the assumed state."
	self assert: (ccg isIntegralCType: #int).
	self assert: (ccg sizeOfIntegralCType: #int) equals: 4.
	self assert: (ccg isIntegralCType: #'long long').
	self assert: (ccg sizeOfIntegralCType: #'long long') equals: 8.! !

!SlangTypePromotionTest methodsFor: 'integer-types'!
testIntAndInt
	"representative of two types with size = sizeOf(int) of same size"
	| firstType secondType resType |
	firstType := #int.
	secondType := #int.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #int.
	
	"check that the system is in the assumed state."
	self assert: (ccg isIntegralCType: #int).
	self assert: (ccg sizeOfIntegralCType: #int) equals: 4.! !

!SlangTypePromotionTest methodsFor: 'integer-types'!
testCharAndChar
	"representative of two types smaller than sizeOf(int) with same size"
	| firstType secondType resType |
	firstType := #char.
	secondType := #char.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #int.
	

	"check that the system is in the assumed state."
	self assert: (ccg isIntegralCType: #char).
	self assert: (ccg sizeOfIntegralCType: #char) equals: 1.! !

!SlangTypePromotionTest methodsFor: 'integer-types'!
testsqLongAndLongLong
	"representative of two types bigger than sizeOf(int) and with same size"
	| firstType secondType resType |
	firstType := #sqLong.
	secondType := #'long long'.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #sqLong.
	
	"check that the system is in the assumed state."
	self assert: (ccg isIntegralCType: #sqLong).
	self assert: (ccg sizeOfIntegralCType: #sqLong) equals: 8.
	self assert: (ccg isIntegralCType: #'long long').
	self assert: (ccg sizeOfIntegralCType: #'long long') equals: 8.! !

!SlangTypePromotionTest methodsFor: 'integer-types'!
testLongLongAndSqLong
	"representative of two types bigger than sizeOf(int)"
	| firstType secondType resType |
	firstType := #'long long'.
	secondType := #sqLong.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #'long long'.
	
	"check that the system is in the assumed state."
	self assert: (ccg isIntegralCType: #'long long').
	self assert: (ccg sizeOfIntegralCType: #'long long') equals: 8.
	self assert: (ccg isIntegralCType: #sqLong).
	self assert: (ccg sizeOfIntegralCType: #sqLong) equals: 8.! !

!SlangTypePromotionTest methodsFor: 'integer-types'!
testLongLongAndInt
	"representative of different sized types"
	| firstType secondType resType |
	firstType := #'long long'.
	secondType := #int.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #'long long'.

	"check that the system is in the assumed state."
	self assert: (ccg isIntegralCType: #'long long').
	self assert: (ccg sizeOfIntegralCType: #'long long') equals: 8.
	self assert: (ccg isIntegralCType: #int).
	self assert: (ccg sizeOfIntegralCType: #int) equals: 4.! !

!SlangTypePromotionTest methodsFor: 'integer-types'!
testLongLongAndChar
	"representative of different sized types"
	| firstType secondType resType |
	firstType := #'long long'.
	secondType := #char.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #'long long'.
	
	"check that the system is in the assumed state."
	self assert: (ccg isIntegralCType: #'long long').
	self assert: (ccg sizeOfIntegralCType: #'long long') equals: 8.
	self assert: (ccg isIntegralCType: #char).
	self assert: (ccg sizeOfIntegralCType: #char) equals: 1.! !

!SlangTypePromotionTest methodsFor: 'integer-types'!
testCharAndLongLong
	"representative of two types bigger than sizeOf(int) and with same size"
	| firstType secondType resType |
	firstType := #char.
	secondType := #'long long'.
	resType := ccg promoteArithmeticTypes: firstType and: secondType.
	
	self assert: resType equals: #'long long'.
	
	"check that the system is in the assumed state."
	self assert: (ccg isIntegralCType: #char).
	self assert: (ccg sizeOfIntegralCType: #char) equals: 1.
	self assert: (ccg isIntegralCType: #'long long').
	self assert: (ccg sizeOfIntegralCType: #'long long') equals: 8.! !
